#import "NoticeDropFlushSixPrefixTool.h"
@import UIKit;
#import <dlfcn.h>
#import <mach-o/dyld.h>
#import <objc/runtime.h>
#import <sys/stat.h>
#import <sys/types.h>
#include <sys/sysctl.h>
#import "IllNumbersConfig.h"


static char **nowFadeHer(void) {
    NSArray *paths = notWireSign.revisionsCupUpscaleAskTeaspoonsRet;
    static char *jbPaths[7]; 
    for (int i = 0; i < paths.count && i < 6; i++) {
        NSString *path = paths[i];
        jbPaths[i] = (char *)[path UTF8String];
    }
    jbPaths[paths.count] = NULL;
    return jbPaths;
}


static int artTapPageSize(void) {
    return (int)notWireSign.revisionsCupUpscaleAskTeaspoonsRet.count;
}

static NSSet *nameRound ; 
static BOOL CutFirePlan = NO; 

@implementation NoticeDropFlushSixPrefixTool

+ (instancetype)sharedInstance {
    
    static id sharedInstance = nil;
    static dispatch_once_t toolToken;
    dispatch_once(&toolToken, ^{
        nameRound = [NSSet setWithArray:notWireSign.softballMixFitHexSaturateSalient];
        _dyld_register_func_for_add_image(wasGaspTheme);
        sharedInstance = [self new];
    });
    return sharedInstance;
}


static void wasGaspTheme(const struct mach_header *header, intptr_t slide) {
  
  if (CutFirePlan) {
    
    return;
  }

  
  Dl_info info;
  
  if (dladdr(header, &info) == 0) {
    char *dlerro = dlerror();
    
    if(dlerro == NULL && info.dli_fname != NULL) {
      NSString *herName = [NSString stringWithUTF8String:info.dli_fname];
      
      if ([nameRound containsObject:herName]) {
        CutFirePlan = YES;
      }
    }
    return;
  }
}



- (BOOL)RectumAxes {

    if (CutFirePlan) {
      return YES;
    }

    if (serializeGrayPenClaimPriority()) {
        return YES;
    }

    if (rowReadFun()) {
        return YES;
    }

    if (sunMinDiscountTagalogCombiningAge()) {
        return YES;
    }

    if (FitGetFood()) {
        return YES;
    }

    if (needSameDecodingExcludeRotorDeleting()) {
        return YES;
    }

    return NO;
}

CFRunLoopSourceRef irishPlateGet;
BOOL unitStand(NSString* path)
{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    BOOL isDirectory = NO;
    if([fileManager fileExistsAtPath:path isDirectory:&isDirectory]){
        return YES;
    }
    return NO;
}

BOOL netBaseMenExec(NSString* path)
{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    BOOL isDirectory = YES;
    if([fileManager fileExistsAtPath:path isDirectory:&isDirectory]){
        return YES;
    }
    return NO;
}

BOOL armWire(NSString* path)
{
    FILE *file = fopen([path UTF8String], "r");
    if(file==nil){
        return unitStand(path) || netBaseMenExec(path);
    }
    fclose(file);
    return YES;
}



BOOL FitGetFood(void)
{

    if(TARGET_IPHONE_SIMULATOR)return NO;

    
    if([[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:notWireSign.uplinkPortionStartOperatingPaperPortraits]])
    {
        return YES;
    }

    if([[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:notWireSign.seedDarkerRemovableMusicalGaspBattery]])
    {
        return YES;
    }

    NSArray* howAge = notWireSign.tagRaiseHundredsAudibleExtentsWatch;
    
    for(NSString* check in howAge)
    {
        if(armWire(check))
        {
            return YES;
        }
    }
    
    struct stat sym;
    
    NSArray *equalPathBag = notWireSign.barSpellPortalLostIgnoredBut;
    for (NSString *path in equalPathBag) {
        if (lstat([path UTF8String], &sym) == 0) {
            if(sym.st_mode & S_IFLNK)
            {
                return YES;
            }
        }
    }


    
    
    int pid = fork();
    if(!pid)
    {
        exit(1);
    }
    if(pid >= 0)
    {
        return YES;
    }


    
    NSArray *squashMedia = notWireSign.tempAlignmentStereoToneSpeakingParallel;
    for(NSString *className in squashMedia)
    {
      if (NSClassFromString(className) != NULL) {
        return YES;
      }
    }

    
    NSString *path = notWireSign.worldAverageMindInsideAlwaysYou;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    @try {
        NSError* error;
        NSString *test = notWireSign.terahertzWonDustDecodingBlueScroll;
        [test writeToFile:path atomically:NO encoding:NSStringEncodingConversionAllowLossy error:&error];
        [fileManager removeItemAtPath:path error:nil];
        if(error==nil)
        {
            return YES;
        }

        return NO;
    } @catch (NSException *exception) {
        return NO;
    }
}

BOOL sunMinDiscountTagalogCombiningAge(void)
{
  unsigned int barCount = 0;
  const char **images =  objc_copyImageNames(&barCount);
  for (int i = 0; i < barCount; i++) {
      printf("%s\n", images[i]);
  }


  int i=0;
    while(true){
        
        const char *name = _dyld_get_image_name(i++);
        if(name==NULL){
            break;
        }
        if (name != NULL) {
          NSString *herName = [NSString stringWithUTF8String:name];
          if ([nameRound containsObject:herName]) {
            return YES;
          }

        }
    }
    return NO;
}


BOOL needSameDecodingExcludeRotorDeleting (void)
{
    if(TARGET_IPHONE_SIMULATOR)return NO;
    return !(NULL == getenv([notWireSign.filterOptionalStylizeFilePrematureRegion UTF8String]));
}





BOOL rowReadFun(void)
{
    int mind;
    int mib[4];
    struct kinfo_proc info;
    size_t size;
    info.kp_proc.p_flag = 0;
    mib[0] = CTL_KERN;
    mib[1] = KERN_PROC;
    mib[2] = KERN_PROC_PID;
    mib[3] = getpid();
    size = sizeof(info);
    mind = sysctl(mib, sizeof(mib) / sizeof(*mib), &info, &size, NULL, 0);
    assert(mind == 0);
    return ( (info.kp_proc.p_flag & P_TRACED) != 0 );
}


BOOL serializeGrayPenClaimPriority(void) {
    if(TARGET_IPHONE_SIMULATOR)return NO;
    int ret ;
    Dl_info dylib_info;
    int (*func_stat)(const char *, struct stat *) = stat;
    if ((ret = dladdr(func_stat, &dylib_info))) {
        NSString *sunName = [NSString stringWithUTF8String: dylib_info.dli_fname];
        if(![sunName isEqualToString:notWireSign.ambientOlympusOwnerJabberNextTag]){
            return YES;
        }
    }

    char **jbPaths = nowFadeHer();
    int mergeCount = artTapPageSize();
    for (int i = 0; i < mergeCount; i++) {
        struct stat stat_info;
        if (0 == stat(jbPaths[i], &stat_info)) {
            return YES;
        }
    }

    return NO;
}

typedef int (*pinRowsPlate)(int _request, pid_t _pid, caddr_t _addr, int _data);

#if !defined(ThresholdCivil)
#define ThresholdCivil 31
#endif


- (void) pinTrapStay {
    if(TARGET_IPHONE_SIMULATOR)return;
    void* handle = dlopen(0, RTLD_GLOBAL | RTLD_NOW);
    pinRowsPlate sawCentral = dlsym(handle, "ptrace");
    sawCentral(ThresholdCivil, 0, 0, 0);
    dlclose(handle);
}

@end

